/**
 *
 * @author Michael Ransburg
 * @version 0.01
 */

import javax.swing.*;
import java.awt.*;
import java.lang.*;

public class About {

  public About() {
  
	final JFrame frame = new JFrame();

	/* close app if someone clicks on X */
	frame.addWindowListener (new java.awt.event.WindowAdapter () {
      public void windowClosing (java.awt.event.WindowEvent evt) {
  	    frame.dispose();
      }
    }
    );

	frame.setTitle("About JNapster");

	frame.setBounds(250,140,800,800);
	frame.setBackground(java.awt.Color.white);

	frame.getContentPane().setLayout(new BorderLayout());
	frame.getContentPane().setBackground(java.awt.Color.black);  

	Icon logo = new ImageIcon("images/jnapster/300er.jpg");
	JLabel logolabel = new JLabel(logo);
	frame.getContentPane().add(logolabel, "North");


	JPanel jpAboutInside = new JPanel();
	jpAboutInside.setBackground(java.awt.Color.black);
	jpAboutInside.setLayout(new java.awt.BorderLayout());

	
	JTextArea jtaAbout = new JTextArea();
    jtaAbout.setLineWrap(true);
	jtaAbout.setWrapStyleWord(true);
  	jtaAbout.setCaretColor (java.awt.Color.red);
  	jtaAbout.setPreferredSize (new java.awt.Dimension(340, 240));
  	jtaAbout.setBackground (java.awt.Color.black);
  	jtaAbout.setForeground (java.awt.Color.red);
  	jtaAbout.setEditable (false);
  	jtaAbout.setSelectedTextColor (java.awt.Color.red);
	jtaAbout.setFont(new Font("Monospaced", 0, 14));

	jtaAbout.append("\n");
	jtaAbout.append("  Name:   Michael Ransburg\n");
	jtaAbout.append("  E-Mail: daneel@tux.org\n");
	jtaAbout.append("  URL:    http://daneel.tsx.org\n\n");
	jtaAbout.append("  Thanks to Hellraiser for the\n");
	jtaAbout.append("  logo! (hellraiser@hellraiser.net)\n\n\n");
	jtaAbout.append("  Where to find me:\n\n");
	jtaAbout.append("    KaraNet BBS: www.karanet.at\n");
	jtaAbout.append("    - look for Daneel!");
	jpAboutInside.add(jtaAbout, "North");

	
	Icon karalogo = new ImageIcon("images/jnapster/kara150.gif");
	JLabel karalogolabel = new JLabel(karalogo);
	jpAboutInside.add(karalogolabel, "Center");


	JPanel jpPlaceHolder = new JPanel();
	jpPlaceHolder.setBackground(java.awt.Color.black);
	jpPlaceHolder.setPreferredSize(new java.awt.Dimension(1, 50));
	jpAboutInside.add(jpPlaceHolder, "South");
		

	frame.getContentPane().add(jpAboutInside, "Center");  


    JPanel jpAbout = new JPanel();
	jpAbout.setBackground(java.awt.Color.black);
    jpAbout.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER));

	JButton jbAbout = new JButton("   Ok   ");
    jbAbout.addActionListener (new java.awt.event.ActionListener () {
      public void actionPerformed (java.awt.event.ActionEvent evt) {
		frame.dispose();
      }
    }
    );

	jpAbout.add(jbAbout);

	frame.getContentPane().add(jpAbout, "South");

	frame.pack();
	frame.show();

  }
}

