/**
 *
 * @author Michael Ransburg
 * @version 0.01
 */

import javax.swing.*;

public class GUI_buttons {

  public GUI_buttons() {
  
    JPanel jpButtons = new JPanel ();
    jpButtons.setPreferredSize (new java.awt.Dimension(500, 35));
    jpButtons.setLayout (new java.awt.FlowLayout (0, 5, 5));

      JButton jbChat = new JButton ();
      jbChat.setText ("Chat");
      jbChat.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
		  GUI.buttons.chat();
        }
      }
      );
      jpButtons.add (jbChat);

      JButton jbLibrary = new JButton ();
      jbLibrary.setEnabled (false);
      jbLibrary.setText ("Library");
      jpButtons.add (jbLibrary);

      JButton jbSearch = new JButton ();
      jbSearch.setText ("Search");
      jbSearch.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
		  GUI.buttons.search();
        }
      }
      );
      jpButtons.add (jbSearch);

      JButton jbHot = new JButton ();
      jbHot.setEnabled (false);
      jbHot.setText ("Hot List");
      jpButtons.add (jbHot);

      JButton jbTransfer = new JButton ();
      jbTransfer.setText ("Transfer");
      jbTransfer.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
		  GUI.buttons.transfer();
        }
      }
	  );
      jpButtons.add (jbTransfer);

      GUI.frame.getContentPane ().add (jpButtons, "North");

  }

  public void search() {

	Thread t = new Thread() {
	  public void run() {
		GUI.content.showSearchContent();				
	  }
	};
	t.start();
  }
  
  public void chat() {

	Thread t = new Thread() {
	  public void run() {
		GUI.content.showTextArea();
	  }
	};
	t.start();
  }

  
  public void transfer() {

	Thread t = new Thread() {
	  public void run() {
		GUI.content.showTransferContent();
	  }
	};
	t.start();
  }  
  
  
}




