/**
 *
 * @author Michael Ransburg
 * @version 0.01
 */

import javax.swing.*;
import javax.swing.table.*;

  public class GUI_content {

  private JTextArea jtaContent;
  private JScrollPane jspContent;

  private JTable jtaSearch;
  private DefaultTableModel dtmSearch;
  private JPanel jpaSearch;
  private JScrollPane jspSearch;

  private JTable jtaTransfer;
  private DefaultTableModel dtmTransfer;
  private JPanel jpaTransfer;
  private JScrollPane jspTransfer;

  private int searchinit = 0;
  private int chatinit = 0;
  private int transferinit = 0;

  public GUI_content() {
  
	Icon logo = new ImageIcon("images/jnapster/600er.jpg");
	JLabel logoLabel = new JLabel(logo);
	logoLabel.setOpaque(true);
	logoLabel.setBackground(java.awt.Color.black);

	jspContent = new JScrollPane(logoLabel);		

    jspContent.setPreferredSize(new java.awt.Dimension(700, 500));

    GUI.frame.getContentPane().add(jspContent, "Center");
  }

  public void showSearchContent() {

  	jpaSearch = new JPanel();
	jpaSearch.setBackground(java.awt.Color.white);
	jpaSearch.setLayout(new java.awt.BorderLayout());

	JPanel jpaSearchTop = new JPanel();
	jpaSearchTop.setBackground(java.awt.Color.white);
//	jpaSearchTop.setLayout(new java.awt.FlowLayout(0,5,5));
	jpaSearchTop.setLayout(new java.awt.BorderLayout());
	jpaSearchTop.setPreferredSize(new java.awt.Dimension(680,70)); // blah


	final JTextField jteSearch = new JTextField(20);
	JButton jbSearch = new JButton("Search");
	JPanel jpaFirst = new JPanel();
	jpaFirst.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));
	jpaFirst.setBackground(java.awt.Color.white);
	jpaFirst.add(jteSearch);
	jpaFirst.add(jbSearch);
	jpaSearchTop.add(jpaFirst, "North");


	JButton jbDownload = new JButton("Download Selected Song");
	JButton jbCheck = new JButton("Check Availability");
	JButton jbBrowse = new JButton("Browse Files of selected User");
	JPanel jpaSecond = new JPanel();
	jpaSecond.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));
	jpaSecond.setBackground(java.awt.Color.white);
	jpaSecond.add(jbDownload);
	jpaSecond.add(jbCheck);
	jpaSecond.add(jbBrowse);
	jpaSearchTop.add(jpaSecond, "West");


	jpaSearch.add(jpaSearchTop, "North");

  	jbSearch.addActionListener (new java.awt.event.ActionListener () {
  	  public void actionPerformed (java.awt.event.ActionEvent evt) {
		if (Main.comm.loggedIn() == 1) {
  	  	  Search search = new Search(jteSearch.getText().trim());
		}
		else {
		  GUI.status.changeStatus("Please File-->Connect first :)");
		}
	  }
  	}
  	);
	
  	jbDownload.addActionListener (new java.awt.event.ActionListener () {
  	  public void actionPerformed (java.awt.event.ActionEvent evt) {
		int rowindex = jtaSearch.getSelectedRow();
		
		if (rowindex == -1) { // nothing selected
		  GUI.status.changeStatus("Please select a row first");
		}
		else { // get the values of the selected row
		  System.out.println(rowindex);
		  String nick = (String)dtmSearch.getValueAt(rowindex, 5);
		  String file = (String)dtmSearch.getValueAt(rowindex, 8);
		  String file_short = (String)dtmSearch.getValueAt(rowindex, 0);
		  String speed = (String)dtmSearch.getValueAt(rowindex, 7);
		  String filesize = (String)dtmSearch.getValueAt(rowindex, 1);
		
		  Download download = new Download(nick, file, file_short, speed, filesize);
		}
  	  }
  	}
  	);

	jbBrowse.addActionListener (new java.awt.event.ActionListener () {
	  public void actionPerformed (java.awt.event.ActionEvent evt) {
		int rowindex = jtaSearch.getSelectedRow();

		if (rowindex == -1) { // nothing selected
		  GUI.status.changeStatus("Please select a row first");
		}
		else {
		  String nick = (String)dtmSearch.getValueAt(rowindex, 5);
		  String length = (String)dtmSearch.getValueAt(rowindex, 4);
		  String ip = (String)dtmSearch.getValueAt(rowindex, 6);
		  String link = (String)dtmSearch.getValueAt(rowindex, 7);
		
		  Browse browse = new Browse(nick, ip, length, link);
		}
  	  }
  	}
  	);
	  



  	jbCheck.addActionListener (new java.awt.event.ActionListener () {
  	  public void actionPerformed (java.awt.event.ActionEvent evt) {
		final int rowindex = jtaSearch.getSelectedRow();

		if (rowindex == -1) { // nothing selected
		  GUI.status.changeStatus("Please select a row first");
		}
		else {
		  final String nick = (String)dtmSearch.getValueAt(rowindex, 5);
		  final String file = (String)dtmSearch.getValueAt(rowindex, 8);
		  final String file_short = (String)dtmSearch.getValueAt(rowindex, 0);
		  final String speed = (String)dtmSearch.getValueAt(rowindex, 7);
		  final String filesize = (String)dtmSearch.getValueAt(rowindex, 1);

		  final Thread u = new Thread() {
			public void run() {

			  Checkhost check = new Checkhost(nick, file, file_short, speed, filesize, rowindex);
			
			}
		  };

		  u.start();

		}
  	  }
  	}
  	);

	jspSearch = new JScrollPane();
	jspSearch.setPreferredSize(new java.awt.Dimension(600, 400));

	if (searchinit == 0) {	  

	  Object[] colnames = {"Filename", "Filesize", "Bitrate", "Frequency", "Length", "User", "IP", "Line Speed", "Filename_full", "Available"};
	  dtmSearch = new DefaultTableModel(colnames,0);
	
	}


	jtaSearch = new JTable(dtmSearch);
	jtaSearch.setShowGrid(false);
	
	jspSearch.setViewportView(jtaSearch);
	jpaSearch.add(jspSearch, "South");
	jspContent.setViewportView(jpaSearch);

	System.out.println("search1");
	  
	GUI.content.hideSearchContent(); //hide ip & long file name

//	TableColumn column = jtaSearch.getColumn("Filename"); //set width
//	column.setMinWidth(200);
	
//	jtaSearch.sizeColumnsToFit(javax.swing.JTable.AUTO_RESIZE_SUBSEQUENT_COLUMNS); //resize columns to width

    GUI.frame.show();
	  
    searchinit = 1;

	if (transferinit == 0) {
	  Object[] colnames = {"Filename", "Filesize", "User", "Status", "Speed", "Progress", "Rate", "Time Left"};
	  dtmTransfer = new DefaultTableModel(colnames,0);	
	  
	  transferinit = 1;
	}

  }

  public void updateSearchContent(int row, String filename_short, String size, String bitrate, String frequency, String length, String nick, String ip, String link, String filename_full, String available) {

	Object[] rowline = {filename_short, size, bitrate, frequency, length, nick, ip, link, filename_full, available};
	dtmSearch.addRow(rowline);

  }

  public void hideSearchContent() {
  
	TableColumn column = jtaSearch.getColumn("IP");	
	TableColumnModel tcm = jtaSearch.getColumnModel();
	tcm.removeColumn(column);
	column = jtaSearch.getColumn("Filename_full");
	tcm.removeColumn(column);
	jtaSearch.sizeColumnsToFit(-1);
  
  }

  public void changeAvailabilitySearchContent(int rowid, String availability) {
	
	dtmSearch.setValueAt(availability, rowid, 9);

  }

  public void clearSearchContent() {

	dtmSearch.setNumRows(0);  
  
  }

  public void showTextArea() {
  
	if (chatinit == 0) {
  
      jtaContent = new JTextArea ();
	  jtaContent.setLineWrap(true);
	  jtaContent.setWrapStyleWord(true);
  	  jtaContent.setCaretColor (java.awt.Color.red);
  	  jtaContent.setPreferredSize (new java.awt.Dimension(600, 400));
  	  jtaContent.setBackground (java.awt.Color.black);
  	  jtaContent.setForeground (java.awt.Color.red);
  	  jtaContent.setEditable (false);
  	  jtaContent.setSelectedTextColor (java.awt.Color.red);

	  jspContent.setViewportView(jtaContent);
	  GUI.frame.show();
	  GUI.frame.repaint();
	  
	  chatinit = 1;
	  System.out.println("chat");
	}
	
	else {
	
	  jspContent.setViewportView(jtaContent);
	  GUI.frame.show();
	  
	  System.out.println("chat2");
	}
  }

  public int getRowsTextArea() {
	return jtaContent.getRows();
  }

  public void changecontent(String text) {
	jtaContent.setText(text);  
  }

  public void appendcontent(String text) {
	jtaContent.append(text);
  }



  public void showTransferContent() {

	if (transferinit == 0) {

	  Object[] colnames = {"Filename", "Filesize", "User", "Status", "Speed", "Progress", "Rate", "Time Left"};
	  dtmTransfer = new DefaultTableModel(colnames,0);

	}


  	jpaTransfer = new JPanel();
	jpaTransfer.setBackground(java.awt.Color.white);
	jpaTransfer.setLayout(new java.awt.BorderLayout());

	JPanel jpaTransferTop = new JPanel();
	jpaTransferTop.setBackground(java.awt.Color.white);
	jpaTransferTop.setLayout(new java.awt.FlowLayout(0,5,5));

	JButton jbTransfer = new JButton("Abort Selected Transfer");
	jpaTransferTop.add(jbTransfer);

	jpaTransfer.add(jpaTransferTop, "North");

  	jbTransfer.addActionListener (new java.awt.event.ActionListener () {
  	  public void actionPerformed (java.awt.event.ActionEvent evt) {

		int rowindex = jtaTransfer.getSelectedRow();

		if (rowindex == -1) { // nothing selected
		  GUI.status.changeStatus("Please select a row first");
		}
		else { // get the values of the selected row

		  System.out.println("RowIndex2: " + rowindex);
		  Thread killerThread = Download.getThread(rowindex);
		  killerThread.stop();
		  GUI.content.changeStatusTransferContent(rowindex, "aborted");
		  
		}
  	  }
  	}
  	);
	
	jspTransfer = new JScrollPane();
	jspTransfer.setPreferredSize(new java.awt.Dimension(600, 400));

	jtaTransfer = new JTable(dtmTransfer);
	jtaTransfer.setShowGrid(false);
	
	jspTransfer.setViewportView(jtaTransfer);
	jpaTransfer.add(jspTransfer, "South");
	jspContent.setViewportView(jpaTransfer);

//	TableColumn column = jtaTransfer.getColumn("Filename"); //set width
//	column.setMinWidth(200);
	
//	jtaTransfer.sizeColumnsToFit(javax.swing.JTable.AUTO_RESIZE_SUBSEQUENT_COLUMNS); //resize columns to width

	System.out.println("transfer1");
	  
    GUI.frame.show();
	  
    transferinit = 1;

  }



  public int addRowTransferContent(String filename, String size, String user, String status, String speed, String progress, String rate, String time_left) {
	Object[] rowline = {filename, size, user, status, speed, progress, rate, time_left};
	dtmTransfer.addRow(rowline);
	
	System.out.print("ROWCOUNT ");
	System.out.println(dtmTransfer.getRowCount());
	
	return dtmTransfer.getRowCount() - 1;	

  }

  public void changeProgressTransferContent(int rowid, long progress) {
	String output = Long.toString(progress);
	dtmTransfer.setValueAt(output, rowid, 5);
  }

  public void changeStatusTransferContent(int rowid, String status) {
	dtmTransfer.setValueAt(status, rowid, 3);  
	System.out.println("changeStatusReached");
  }

  public void delRowTransferContent(int rowid) {
	dtmTransfer.removeRow(rowid);
  }

  public void clearTransferContent() {

	dtmTransfer.setNumRows(0);  
  
  }

}