/**
 *
 * @author Michael Ransburg
 * @version 0.01
 */

import javax.swing.*;

public class GUI_menu {

  public GUI_menu() {

    JMenuBar menuBar = new JMenuBar ();
    menuBar.setPreferredSize (new java.awt.Dimension(205, 19));

      JMenu fileMenu = new JMenu ();
      fileMenu.setText ("File");
      fileMenu.setName ("File");

        JMenuItem jmiConnect = new JMenuItem ();
	    jmiConnect.setEnabled (true);
        jmiConnect.setText ("Connect");
		jmiConnect.addActionListener(new java.awt.event.ActionListener() {
		  public void actionPerformed(java.awt.event.ActionEvent evt) {
			GUI.menu.connect();
		  }
		}
		);
        fileMenu.add(jmiConnect);

	    JMenuItem jmiDisconnect = new JMenuItem ();
        jmiDisconnect.setEnabled (false);
    	jmiDisconnect.setText ("Disconnect");
        fileMenu.add(jmiDisconnect);

	    fileMenu.addSeparator();

        JMenuItem jmiPreferences = new JMenuItem ();
	    jmiPreferences.setEnabled (false);
	    jmiPreferences.setText ("Preferences");
	    fileMenu.add(jmiPreferences);

	    fileMenu.addSeparator();

	    JMenuItem jmiExit = new JMenuItem ();
	    jmiExit.setText ("Exit");
	    jmiExit.addActionListener (new java.awt.event.ActionListener () {
	      public void actionPerformed (java.awt.event.ActionEvent evt) {
			System.exit(0);
		  }
		}
	    );
		fileMenu.add(jmiExit);

	  menuBar.add(fileMenu);


      JMenu actionMenu = new JMenu ();
      actionMenu.setEnabled (false);
      actionMenu.setText ("Actions");
      actionMenu.setLabel ("Actions");

	    JMenuItem jmiJoin = new JMenuItem ();
	    jmiJoin.setText ("Join Chat Rooms");
	    actionMenu.add(jmiJoin);

	    JMenuItem jmiAdd = new JMenuItem ();
	    jmiAdd.setText ("Add User to Hot List");
	    actionMenu.add(jmiAdd);

	    JMenuItem jmiResume = new JMenuItem ();
	    jmiResume.setText ("Resume Files");
	    actionMenu.add(jmiResume);

	  menuBar.add(actionMenu);
  

      JMenu helpMenu = new JMenu ();
      helpMenu.setText ("Help");

	    JMenuItem jmiAbout = new JMenuItem ();
	    jmiAbout.setText ("About JNapster");
	    jmiAbout.addActionListener (new java.awt.event.ActionListener () {
	      public void actionPerformed (java.awt.event.ActionEvent evt) {
			GUI.menu.About();
		  }
		}
	    );
	    helpMenu.add(jmiAbout);

	    helpMenu.addSeparator();

	    JMenuItem jmiFaq = new JMenuItem ();
		jmiFaq.setEnabled(false);
	    jmiFaq.setText ("Napster FAQ");
	    helpMenu.add(jmiFaq);

  		helpMenu.addSeparator();

	    JMenuItem jmiFeedback = new JMenuItem ();
	    jmiFeedback.setText ("Send Feedback");
	    jmiFeedback.addActionListener (new java.awt.event.ActionListener () {
	      public void actionPerformed (java.awt.event.ActionEvent evt) {
			GUI.menu.Feedback();
		  }
		}
	    );
	    helpMenu.add(jmiFeedback);

	  menuBar.add(helpMenu);


    GUI.frame.setJMenuBar(menuBar);

  }

  public void connect() {
	Thread t = new Thread() {
	  public void run() {


		LoginDialog logindialog = new LoginDialog();
/*
		String content;

		GUI.status.changeStatus("Connecting ... please wait");
		GUI.content.showTextArea();				
		Main.comm.Login();
		while (!Main.comm.vecContent.isEmpty()) {
		  content = (String)Main.comm.vecContent.firstElement();
		  
		  GUI.content.appendcontent("                 ");
		  GUI.content.appendcontent(content);

		  Main.comm.vecContent.removeElement(Main.comm.vecContent.firstElement());

		}
		GUI.status.changeStatus("Connected to Napster server :)");

*/

	  }
	};
	t.start();
  }


  public void About() {
	Thread t = new Thread() {
	  public void run() {

		About about = new About();

	  }
	};
	t.start();
  }

  public void Feedback() {
	Thread t = new Thread() {
	  public void run() {
	  
		Feedback feedback = new Feedback();
	
	  }
	};
	t.start();
  }

}



